#pragma once

#include "GameObject.h"

enum GegenstandTyp
{
    KEIN_GEGENSTAND,
    PFEIL,
    LEBEN,
    SCHILD,
    SCHUH,
    GEIST,
    KUGEL,
    ROLLE,
    STURM,
    DRACHENAUGE,
    FEUERBALL,
    ENTERHAKEN,
    MINE,
    RWEISHEIT,
    RSTRENGTH,
    RBOSHEIT,
    RLEBEN,
    RTEMPO,
    ITEMANZAHL
};

class GegenstandTypVar : public Variable
{
private:
    GegenstandTyp value;

public:
    GegenstandTypVar( GegenstandTyp value );
    void setValue( GegenstandTyp value );
    GegenstandTyp getValue() const;
};

class Gegenstand : public GameObject
{
private:
    GegenstandTyp typ;
    bool onMap;
    int id;

public:
    Gegenstand( int id, GegenstandTyp typ, bool onMap = 0, int x = 0, int y = 0, int w = 50, int h = 50 );
    ~Gegenstand();
    bool isOnMap() const;
};